=== debian/changelog ===
retroarch (1.20.0+dfsg-3) unstable; urgency=medium

  * Fix CVE-2025-9136 (out of bounds read) (Closes: 1111614)

 -- Jonathan McDowell <noodles@earth.li>  Sat, 30 Aug 2025 13:20:14 +0100

retroarch (1.20.0+dfsg-2) unstable; urgency=medium

  * Build-depend on libpipewire-0.3-dev (Closes: #1095996)

 -- Jonathan McDowell <noodles@earth.li>  Sat, 15 Feb 2025 17:35:28 +0000

retroarch (1.20.0+dfsg-1) unstable; urgency=medium

  [ Pino Toscano ]
  * Drop the retroarch.svg symlink in the legacy pixmaps location.

  [ Jonathan McDowell ]
  * New upstream release
    * Drop patches/02_set_c++17.patch
    * Switch desktop filename to com.libretro.RetroArch
    * Update debian/copyright

 -- Jonathan McDowell <noodles@earth.li>  Sun, 09 Feb 2025 11:48:11 +0000
